%One-time Pad encryption demo
max_char_to_display = 300;

%Generate a random key
number_bytes_in_key = 16; %128-bit
key = uint8(randi([0 255],1,number_bytes_in_key));

%Get the name of the text file containing the text data to encrypt and load
%the file into memory.
[basename, folder] = uigetfile('*.*');
inFile = fullfile(folder,basename);
fileId = fopen(inFile,'r');
input_data = uint8(fread(fileId))';
fclose(fileId);

%Display the contents of the text file
fprintf('\nInput data from the file:\n');
if(length(input_data) > max_char_to_display)
    disp(char(input_data(1:max_char_to_display)));
else
    disp(char(input_data));
end
fprintf('\n');

%Encrypt the text file using the one-time pad encryption method and the
%randomly generated key
[encrypted_data,encrypted_data_char] = one_time_pad_encrypt(input_data,key);

%Decrypt the encrypted data using the one-time pad encryption method and 
%the randomly generated key
[decrypted_data,decrypted_data_char] = one_time_pad_decrypt(encrypted_data,key);

%Display the results of the encryption process
display_one_time_pad_results(input_data,encrypted_data,decrypted_data,key);

%Write the encrypted data to the disk
outFile = 'encrypted_data';
fileId = fopen(outFile,'w');
fwrite(fileId,encrypted_data);
fclose(fileId);

%Display the decrypted data
fprintf('\nDecrypted data:\n');
if(length(decrypted_data_char) > max_char_to_display)
    disp(decrypted_data_char(1:max_char_to_display));
else
    disp(decrypted_data_char);
end
fprintf('\n');

%Write the decrypted data
outFile = ['decrypted' inFile(find(inFile=='.',1,'last'):end)];
fileId = fopen(outFile,'w');
fwrite(fileId,decrypted_data);
fclose(fileId);